"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.generateInsightChartSpec = void 0;
var strategy_1 = require("../strategy");
function generateInsightChartSpec(insight) {
    var _a;
    var insightType = insight.patterns[0].type;
    var insightType2Strategy = {
        trend: strategy_1.trendStrategy,
        time_series_outlier: strategy_1.timeSeriesOutlierStrategy,
        category_outlier: strategy_1.categoryOutlierStrategy,
        change_point: strategy_1.changePointStrategy,
        low_variance: strategy_1.lowVarianceStrategy,
        majority: strategy_1.majorityStrategy,
        correlation: strategy_1.correlationStrategy,
    };
    var marks = (_a = insightType2Strategy[insightType]) === null || _a === void 0 ? void 0 : _a.call(insightType2Strategy, insight);
    return (0, strategy_1.viewSpecStrategy)(marks, insight);
}
exports.generateInsightChartSpec = generateInsightChartSpec;
