"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.categoryOutlierStrategy = exports.categoryOutlierAugmentedMarksStrategy = void 0;
var tslib_1 = require("tslib");
var lodash_1 = require("lodash");
var utils_1 = require("../../../../utils");
var constants_1 = require("../../constants");
var chart_1 = require("../chart");
var commonMarks_1 = require("../commonMarks");
var utils_2 = require("../../utils");
var categoryOutlierAugmentedMarksStrategy = function (insight) {
    var patterns = insight.patterns;
    if (!(0, lodash_1.size)(patterns))
        return [];
    var categoryOutlierMarks = [];
    patterns.forEach(function (pattern) {
        var rectMark = (0, commonMarks_1.intervalMarkStrategy)([pattern]);
        var textMark = (0, commonMarks_1.textMarkStrategy)([pattern], {
            style: { fontWeight: constants_1.BOLD_FONT_WEIGHT, dy: -8 },
            formatter: utils_1.dataFormat,
        });
        categoryOutlierMarks.push({
            categoryOutlier: [rectMark, textMark],
        });
    });
    return categoryOutlierMarks;
};
exports.categoryOutlierAugmentedMarksStrategy = categoryOutlierAugmentedMarksStrategy;
var categoryOutlierStrategy = function (insight) {
    var chart = (0, chart_1.insight2ChartStrategy)(insight);
    var categoryOutlierMarks = (0, exports.categoryOutlierAugmentedMarksStrategy)(insight);
    var marks = (0, utils_2.augmentedMarks2Marks)(categoryOutlierMarks);
    return tslib_1.__spreadArray([chart], tslib_1.__read(marks), false);
};
exports.categoryOutlierStrategy = categoryOutlierStrategy;
