"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.lowVarianceStrategy = exports.lowVarianceAugmentedMarkStrategy = void 0;
var tslib_1 = require("tslib");
var commonMarks_1 = require("../commonMarks");
var chart_1 = require("../chart");
var utils_1 = require("../../utils");
var utils_2 = require("../../../../utils");
var lowVarianceAugmentedMarkStrategy = function (insight) {
    var patterns = insight.patterns;
    var marks = [];
    patterns.forEach(function (pattern) {
        var mean = pattern.mean;
        var meanLineMark = (0, commonMarks_1.lineMarkStrategy)({ y: mean }, { label: "mean: ".concat((0, utils_2.dataFormat)(mean)) });
        marks.push({
            meanLine: [meanLineMark],
        });
    });
    return marks;
};
exports.lowVarianceAugmentedMarkStrategy = lowVarianceAugmentedMarkStrategy;
var lowVarianceStrategy = function (insight) {
    var chartMark = (0, chart_1.insight2ChartStrategy)(insight);
    var lowVarianceMarks = (0, exports.lowVarianceAugmentedMarkStrategy)(insight);
    var marks = (0, utils_1.augmentedMarks2Marks)(lowVarianceMarks);
    return tslib_1.__spreadArray([chartMark], tslib_1.__read(marks), false);
};
exports.lowVarianceStrategy = lowVarianceStrategy;
