"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.pointMarkStrategy = void 0;
var tslib_1 = require("tslib");
var lodash_1 = require("lodash");
/** get mark for point patterns, the patterns should have same dimension and measure */
var pointMarkStrategy = function (patterns, config) {
    var data = [];
    patterns.forEach(function (_a) {
        var x = _a.x, y = _a.y;
        if ((0, lodash_1.isNil)(x) || (0, lodash_1.isNil)(y))
            return;
        data.push({ x: x, y: y });
    });
    var pointMark = tslib_1.__assign({ type: 'point', data: data, encode: {
            x: 'x',
            y: 'y',
        } }, config);
    return pointMark;
};
exports.pointMarkStrategy = pointMarkStrategy;
